  MEMBER
!---------------------------------------------------------------------------------------------------------------------------
! Class xTransparent v1.6
! Copyright 2001-2004, SealSoft Company
!---------------------------------------------------------------------------------------------------------------------------
  INCLUDE('xTrn.inc'),ONCE
  MAP
    MODULE('Windows API')
      xtrnSetCursorWin(USHORT),PASCAL,USHORT,NAME('SetCursor')
      xtrnGetWindowLong(UNSIGNED, SIGNED), LONG, PASCAL, NAME('GetWindowLongA')
      xtrnSetWindowLong(UNSIGNED, SIGNED, LONG), LONG, PASCAL, NAME('SetWindowLongA')
      xtrnLoadLibrary(*CSTRING),UNSIGNED,PASCAL,RAW,NAME('LoadLibraryA')
      xtrnGetProcAddress(UNSIGNED, *CSTRING),LONG,PASCAL,RAW,NAME('GetProcAddress')
    END
    TrnProc(LONG, LONG, BYTE, LONG), LONG, PASCAL, TYPE ! SetLayeredWindowAttributes in USER32.DLL
    CallTrnProc(TrnProc objProcedure, LONG WinHandle, REAL Transparency),NAME('CallTrnProc')
    MODULE('')
      CallTrnProc(LONG objProcedure, LONG WinHandle, REAL Transparency),NAME('CallTrnProc')
    END
  END
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.Init                 PROCEDURE(WINDOW Window)
  CODE
  SELF.CurWindow   &= Window
  SELF.WindowHandle = Window{PROP:Handle}
  SELF.WindowStyle  = xtrnGetWindowLong(SELF.WindowHandle, xtrnGWL_EXSTYLE)
  SELF.DLLName      = 'USER32.DLL<0>'
  SELF.ProcName     = 'SetLayeredWindowAttributes<0>'
  SELF.DllHandle    = xtrnLoadLibrary(SELF.DLLName)
  SELF.ProcAddress  = xtrnGetProcAddress(SELF.DllHandle, SELF.ProcName)
  SELF.DllLoaded    = FALSE
  SELF.TimerRegistered = FALSE
  IF SELF.ProcAddress
    SELF.DllLoaded = TRUE
  END
  
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.Kill                 PROCEDURE
  CODE
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.SetTransparent       PROCEDURE(REAL TrnPercent)
  CODE
  SELF.TrnPercent = TrnPercent
  IF SELF.TrnPercent < 0 THEN SELF.TrnPercent = 0 END
  IF SELF.TrnPercent > 100 THEN SELF.TrnPercent = 100 END
  SELF.BeginPercent = SELF.TrnPercent
  SELF.SetTrn
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.SetTrn               PROCEDURE
  CODE
  IF SELF.DllLoaded = TRUE
    Err# = xtrnSetWindowLong(SELF.WindowHandle, xtrnGWL_EXSTYLE, SELF.WindowStyle + xtrnWS_EX_LAYERED)
    CallTrnProc(SELF.ProcAddress, SELF.WindowHandle, SELF.TrnPercent)
  END
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.GetTrnPercent        PROCEDURE()
LOC:Result                   BYTE
  CODE
  LOC:Result = SELF.TrnPercent
  RETURN LOC:Result
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.SetOTimer            PROCEDURE(BYTE OFadeTime, BYTE EndPercent)
  CODE
  SELF.OFadeTime  = OFadeTime
  SELF.EndPercent = EndPercent
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.StartTimer           PROCEDURE
  CODE
  IF SELF.DllLoaded = TRUE
    SELF.OldTimer = SELF.CurWindow{PROP:Timer}
    SELF.OOffset = (SELF.EndPercent - SELF.BeginPercent) / SELF.OFadeTime
    SELF.STimerEnabled = TRUE
    SELF.CurWindow{PROP:Timer} = 1
    REGISTER(EVENT:Timer, ADDRESS(SELF.Timer),ADDRESS(SELF))
    SELF.TimerRegistered = TRUE
  END
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.Timer                PROCEDURE()
  CODE
  IF SELF.DllLoaded = TRUE
    IF SELF.STimerEnabled = TRUE
      IF SELF.TrnPercent >= SELF.EndPercent
        SELF.STimerEnabled = FALSE
        SELF.CurWindow{PROP:Timer} = SELF.OldTimer
        RETURN 0
      END
      SELF.TrnPercent += SELF.OOffset
      SELF.SetTransparent(SELF.TrnPercent)
    END
    IF SELF.BeginCFade = TRUE
      IF SELF.TrnPercent <= SELF.CEndPercent
        !MESSAGE('End FadeOut')
        SELF.cFadeTime  = 0
        SELF.BeginCFade = FALSE
        SELF.CurWindow{PROP:Timer} = SELF.OldTimer
        POST(EVENT:CloseWindow)
        RETURN 0
      END
      SELF.TrnPercent -= SELF.COffset
      SELF.SetTransparent(SELF.TrnPercent)
      !MESSAGE('TrnPercent: ' & SELF.TrnPercent)
    END
  END
  RETURN 0
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.SetCTimer            PROCEDURE(BYTE cFadeTime, BYTE cEndPercent)
  CODE
  SELF.CFadeTime   = CFadeTime
  SELF.CEndPercent = CEndPercent
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.WCloseEvent          PROCEDURE()
  CODE
  IF SELF.DllLoaded = TRUE
    IF SELF.cFadeTime > 0
      IF SELF.STimerEnabled = TRUE
        SELF.STimerEnabled = FALSE
        SELF.CurWindow{PROP:Timer} = SELF.OldTimer
      END
      SELF.OldTimer = SELF.CurWindow{PROP:Timer}
      SELF.COffset = (SELF.TrnPercent - SELF.cEndPercent) / SELF.cFadeTime
      !MESSAGE('Sart FadeOut: ' & SELF.COffset)
      SELF.CurWindow{PROP:Timer} = 1
      SELF.BeginCFade = TRUE
    ELSE
      RETURN 0
    END     
    RETURN 3
  END
  RETURN 0
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.StartCloseEvent      PROCEDURE
  CODE
  IF SELF.DllLoaded = TRUE
    REGISTER(EVENT:CloseWindow, ADDRESS(SELF.WCloseEvent),ADDRESS(SELF))
    IF SELF.TimerRegistered = FALSE
      REGISTER(EVENT:Timer, ADDRESS(SELF.Timer),ADDRESS(SELF))
      SELF.TimerRegistered = TRUE
    END
  END
!---------------------------------------------------------------------------------------------------------------------------
!
!---------------------------------------------------------------------------------------------------------------------------
xTransparentClass.IsDllLoaded          PROCEDURE()
  CODE
  RETURN SELF.DllLoaded
CallTrnProc                            PROCEDURE(TrnProc objProcedure, LONG WinHandle, REAL Transparency)
 CODE
 Err# = objProcedure(WinHandle, 0, (255 * Transparency) / 100, xtrnLWA_ALPHA)
